<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<!-- 
IGAC proyecto SNC
@author 			rodrigo.hernandez
@cu 				CU-SA-AC-100
@ManagedBean        ProyeccionCotizacionAvaluoMB
-->

<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:fn="http://java.sun.com/jsp/jstl/functions"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:p="http://primefaces.org/ui"
                template="../../templates/generalCU.xhtml"
                xmlns:misc="http://java.sun.com/jsf/composite/misc"
                xmlns:predio="http://java.sun.com/jsf/composite/predio"
                xmlns:avaluos="http://java.sun.com/jsf/composite/avaluos">

    <ui:define name="title">
        .::Sistema Nacional Catastral::. .::Proyectar cotización::.
    </ui:define>

    <ui:define name="content">

        <h:outputScript library="javascript" name="snc_visor_client.js"
                        target="head" />
        <h:outputStylesheet library="css" name="snc_visor_client.css" />

        <h:form id="proyectarCotizacionAvaluoForm">
            <p:messages showDetail="false" globalOnly="false" />

            <p:fieldset id="proyectarCotizacionAvaluoFS">

                <h:panelGrid width="100%">

                    <h:panelGrid columns="4" width="100%"
                                 columnClasses="colPequena, colPequena, colPequena, colPequena">

                        <h:outputLabel value="Número oficina:"
                                       styleClass="outputLabelStyle" />
                        <h:outputText
                            value="#{proyectarCotizacionAvaluo.territorialAvaluo.codigo}"
                            styleClass="outputTextStyle" />

                        <h:outputLabel value="Fecha documento:"
                                       styleClass="outputLabelStyle" />
                        <h:outputText value="#{proyectarCotizacionAvaluo.fechaDocumento}"
                                      styleClass="outputTextStyle">
                            <f:convertDateTime pattern="#{general.formatoFechaUsuario2}" />
                        </h:outputText>

                        <p:spacer height="10" />
                        <p:spacer height="10" />
                        <p:spacer height="10" />
                        <p:spacer height="10" />

                        <h:outputLabel value="Sec. Radicado" styleClass="outputLabelStyle" />
                        <p:commandLink styleClass="commandLinkStyle"
                                       action="#{consultaInformacionSolicitud.consultarSecRadicado}"
                                       update=":isCC:infoSolicitudTV" onstart="statusDialog2.show();"
                                       oncomplete="infoSolicitudCCWV.show(); statusDialog2.hide()"
                                       value="#{proyectarCotizacionAvaluo.avaluo.secRadicado}">
                            <f:setPropertyActionListener
                                value="#{proyectarCotizacionAvaluo.avaluo.secRadicado}"
                                target="#{consultaInformacionSolicitud.numeroSecRadicado}" />
                        </p:commandLink>

                        <p:spacer />
                        <p:spacer />

                        <h:outputLabel value="Radicado No." styleClass="outputLabelStyle" />
                        <p:commandLink styleClass="commandLinkStyle"
                                       action="#{consultaInformacionSolicitud.consultarSolicitud}"
                                       update=":isCC:infoSolicitudTV" onstart="statusDialog2.show();"
                                       oncomplete="infoSolicitudCCWV.show(); statusDialog2.hide()"
                                       value="#{proyectarCotizacionAvaluo.avaluo.tramite.solicitud.numero}">
                            <f:setPropertyActionListener
                                value="#{proyectarCotizacionAvaluo.avaluo.tramite.solicitud.numero}"
                                target="#{consultaInformacionSolicitud.numeroSolicitud}" />
                        </p:commandLink>
                        <p:spacer />
                        <p:spacer />

                        <h:outputLabel value="Fecha de radicado"
                                       styleClass="outputLabelStyle" />
                        <h:outputText
                            value="#{proyectarCotizacionAvaluo.avaluo.tramite.solicitud.fecha}"
                            styleClass="outputTextStyle">
                            <f:convertDateTime pattern="#{general.formatoFechaUsuario2}" />
                        </h:outputText>

                        <h:outputLabel value="Director territorial"
                                       styleClass="outputLabelStyle" />
                        <h:outputText
                            value="#{proyectarCotizacionAvaluo.directorTerritorial.nombreCompleto}"
                            styleClass="outputTextStyle" />

                        <h:outputLabel value="Solicitante" styleClass="outputLabelStyle" />
                        <h:outputText
                            value="#{proyectarCotizacionAvaluo.avaluo.solicitante.nombreCompleto}"
                            styleClass="outputTextStyle" />

                        <h:outputLabel value="Subdirector de catastro"
                                       styleClass="outputLabelStyle" />
                        <h:outputText
                            value="#{proyectarCotizacionAvaluo.subdirectorCatastro.nombreCompleto}"
                            styleClass="outputTextStyle" />

                        <h:outputLabel value="Representante legal"
                                       styleClass="outputLabelStyle" />
                        <h:outputText
                            value="#{proyectarCotizacionAvaluo.avaluo.tramite.solicitud.representanteLegal.nombreCompleto}"
                            styleClass="outputTextStyle" />

                        <h:outputLabel value="Municipio de territorial "
                                       styleClass="outputLabelStyle" />
                        <h:outputText styleClass="outputTextStyle"
                                      id="TerritorialesConDireccionGeneral-1"
                                      value="#{proyectarCotizacionAvaluo.territorialAvaluo.codigo}">
                            <f:converter converterId="converterCB"
                                         for="TerritorialesConDireccionGeneral-1" />
                        </h:outputText>

                        <h:outputLabel value="Cargo" styleClass="outputLabelStyle" />
                        <h:outputText
                            value="#{proyectarCotizacionAvaluo.avaluo.tramite.solicitud.representanteLegal.cargo}"
                            styleClass="outputTextStyle" />

                        <h:outputLabel value="Valor Total cotización"
                                       styleClass="outputLabelStyle" />
                        <h:outputText value="#{proyectarCotizacionAvaluo.totalCotizacion}"
                                      styleClass="outputTextStyle">
                            <f:converter converterId="converterMoneda" />
                        </h:outputText>

                        <h:outputLabel value="Dirección correspondencia"
                                       styleClass="outputLabelStyle" />
                        <h:outputText
                            value="#{proyectarCotizacionAvaluo.avaluo.solicitante.direccion}"
                            styleClass="outputTextStyle" />

                        <h:outputLabel value="Contrato" styleClass="outputLabelStyle" />
                        <h:selectOneRadio id="generaContrato" label="Genera contrato"
                                          value="#{proyectarCotizacionAvaluo.banderaGeneraContrato}">

                            <f:selectItem itemLabel="SI" itemValue="true" />
                            <f:selectItem itemLabel="NO" itemValue="false" />

                            <p:ajax process="@this"
                                    listener="#{proyectarCotizacionAvaluo.onChangeRealizaContrato}" />
                        </h:selectOneRadio>

                        <h:outputLabel value="Departamento" styleClass="outputLabelStyle" />
                        <p:commandLink
                            value="#{proyectarCotizacionAvaluo.avaluo.avaluosPredios[0].departamento.nombre}"
                            rendered="#{proyectarCotizacionAvaluo.avaluo.tienePrediosEnDiferentesDeptos}"
                            styleClass="commandLinkStyle"
                            action="#{consultarDptoMunpioAvaluo.cargarDeptosMunisAvaluo}"
                            update=":consultarDepartamentosMunicipioForm"
                            onstart="statusDialog2.show();"
                            oncomplete="statusDialog2.hide();
                            handleCompleteSIC(xhr, status, args, infoDeptosMunisWV, true);">
                            <f:setPropertyActionListener
                                value="#{proyectarCotizacionAvaluo.avaluo}"
                                target="#{consultarDptoMunpioAvaluo.avaluoSeleccionado}" />
                        </p:commandLink>

                        <h:outputText
                            rendered="#{!avaluoCancelado.tienePrediosEnDiferentesDeptos}"
                            value="#{proyectarCotizacionAvaluo.avaluo.avaluoPredios[0].departamento.codigo} - #{proyectarCotizacionAvaluo.avaluo.avaluoPredios[0].departamento.nombre}" />


                        <h:outputLabel value="Anexos" styleClass="outputLabelStyle" />
                        <h:panelGrid columns="2">
                            <p:inputMask id="foliosAnexos"
                                         value="#{proyectarCotizacionAvaluo.foliosAnexos}" mask="999"
                                         style="width:20px" />
                            <h:outputLabel value="Folios" styleClass="outputLabelStyle" />
                        </h:panelGrid>

                        <h:outputLabel value="Municipio" styleClass="outputLabelStyle" />
                        <p:commandLink
                            value="#{proyectarCotizacionAvaluo.avaluo.avaluosPredios[0].departamento.nombre}"
                            rendered="#{proyectarCotizacionAvaluo.avaluo.tienePrediosEnDiferentesDeptos}"
                            styleClass="commandLinkStyle"
                            action="#{consultarDptoMunpioAvaluo.cargarDeptosMunisAvaluo}"
                            update=":consultarDepartamentosMunicipioForm"
                            onstart="statusDialog2.show();"
                            oncomplete="statusDialog2.hide();
                            handleCompleteSIC(xhr, status, args, infoDeptosMunisWV, true);">
                            <f:setPropertyActionListener
                                value="#{proyectarCotizacionAvaluo.avaluo}"
                                target="#{consultarDptoMunpioAvaluo.avaluoSeleccionado}" />
                        </p:commandLink>

                        <h:outputText
                            rendered="#{!avaluoCancelado.tienePrediosEnDiferentesDeptos}"
                            value="#{proyectarCotizacionAvaluo.avaluo.avaluoPredios[0].municipio.codigo} - #{proyectarCotizacionAvaluo.avaluo.avaluoPredios[0].municipio.nombre}"
                            styleClass="outputTextStyle" />


                        <p:spacer />
                        <p:spacer />

                        <h:outputLabel value="No. Predios" styleClass="outputLabelStyle" />
                        <h:outputText
                            value="#{fn:length(proyectarCotizacionAvaluo.avaluo.avaluoPredios)}"
                            styleClass="outputTextStyle" />

                        <p:spacer />
                        <p:spacer />

                        <h:outputLabel value="Resolución avalúos"
                                       styleClass="outputLabelStyle" />
                        <h:outputText value="FIXME" styleClass="outputTextStyle" />

                    </h:panelGrid>
                </h:panelGrid>
            </p:fieldset>

            <p:spacer height="15" />

            <p:fieldset id="proyectarCotizacionAvaluoCapitulosFS">

                <p:spacer height="10" />

                <legend>
                    <h:outputLabel value="Capítulos incluídos en los cuadernillos"
                                   styleClass="legendTitle" />
                </legend>

                <p:spacer height="10" />

                <p:dataTable id="capitulosDT"
                             value="#{proyectarCotizacionAvaluo.listaCapitulos}" var="capitulo"
                             paginator="true" rows="10" rowKey="#{capitulo.idProvisional}"
                             selection="#{proyectarCotizacionAvaluo.listaCapitulosSeleccionados}"
                             paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {CurrentPageReport}
                             {NextPageLink} {LastPageLink}"
                             rowsPerPageTemplate="10" paginatorPosition="bottom"
                             emptyMessage="No se encontraron capítulos">

                    <p:column style="width: 18px;" selectionMode="multiple" />

                    <p:column style="width: 40px; text-align: center">
                        <f:facet name="header">Opciones</f:facet>
                        <p:outputPanel style="border:0px;width:50px;display:block;">

                            <p:commandButton title="Editar" icon="ui-icon-pencil"
                                             onstart="statusDialog2.show();"
                                             oncomplete="statusDialog2.hide(); otraDescOtroCapWV.show();"
                                             update=":crearActualizarCapituloForm" immediate="true">
                                <f:setPropertyActionListener
                                    target="#{proyectarCotizacionAvaluo.banderaEsAdicionCapitulo}"
                                    value="false" />

                                <f:setPropertyActionListener
                                    target="#{proyectarCotizacionAvaluo.nuevoCapitulo}"
                                    value="#{capitulo}" />
                            </p:commandButton>

                            <p:commandButton title="Eliminar" icon="ui-icon-close"
                                             rendered="#{capitulo.esCreadoPorUsuario}"
                                             onstart="statusDialog2.show();"
                                             oncomplete="statusDialog2.hide(); confirmacionEliminarCapituloWV.show()"
                                             update=":proyectarCotizacionAvaluoForm:proyectarCotizacionAvaluoCapitulosFS"
                                             immediate="true">
                                <f:setPropertyActionListener
                                    target="#{proyectarCotizacionAvaluo.nuevoCapitulo}"
                                    value="#{capitulo}" />
                            </p:commandButton>

                        </p:outputPanel>
                    </p:column>

                    <f:facet name="header">
                        Capítulos incluídos en los cuadernillos
                    </f:facet>

                    <p:column>
                        <f:facet name="header">
                            Título del capítulo
                        </f:facet>
                        <h:outputText value="#{capitulo.titulo}"
                                      styleClass="outputTextStyle" />
                    </p:column>

                    <p:column>
                        <f:facet name="header">
                            Descripción
                        </f:facet>
                        <h:outputText value="#{capitulo.descripcion}"
                                      styleClass="outputTextStyle" />
                    </p:column>

                    <p:column>
                        <f:facet name="header">
                            Otra descripción
                        </f:facet>
                        <h:outputText value="#{capitulo.otraDescripcion}"
                                      styleClass="outputTextStyle" />
                    </p:column>
                </p:dataTable>

                <p:spacer width="15" />

                <p:outputPanel layout="block" style="text-align:left">

                    <p:commandButton value="Adicionar capítulo"
                                     icon="ui-icon ui-icon-plus" onstart="statusDialog2.show();"
                                     oncomplete="statusDialog2.hide(); otraDescOtroCapWV.show();"
                                     action="#{proyectarCotizacionAvaluo.crearCapitulo}"
                                     update=":crearActualizarCapituloForm" immediate="true">
                        <f:setPropertyActionListener
                            target="#{proyectarCotizacionAvaluo.banderaEsAdicionCapitulo}"
                            value="true" />
                    </p:commandButton>

                </p:outputPanel>

                <p:spacer width="15" />


            </p:fieldset>

            <p:spacer width="15" />

            <p:fieldset id="docsRequisitoFS">
                <legend>
                    <h:outputLabel value="Documentación a solicitar"
                                   styleClass="legendTitle" />
                </legend>

                <p:spacer height="10" />

                <p:dataTable id="documentacionDT"
                             value="#{proyectarCotizacionAvaluo.listaDocumentosSeleccionados}"
                             var="documento" paginator="true" rows="10" rowKey="#{documento.id}"
                             paginatorTemplate="{RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {CurrentPageReport}
                             {NextPageLink} {LastPageLink}"
                             rowsPerPageTemplate="10" paginatorPosition="bottom"
                             emptyMessage="No se encontraron capítulos">

                    <f:facet name="header">
                        Documentación a solicitar
                    </f:facet>

                    <p:column style="width: 20px; text-align: center">
                        <f:facet name="header">Opciones</f:facet>
                        <p:outputPanel style="border:0px;width:50px;display:block;">

                            <p:commandButton title="Eliminar" icon="ui-icon-close"
                                             update=":proyectarCotizacionAvaluoForm:docsRequisitoFS"
                                             onstart="statusDialog2.show();"
                                             oncomplete="statusDialog2.hide(); confirmacionEliminarDocRequisitoWV.show()">
                                <f:setPropertyActionListener
                                    target="#{proyectarCotizacionAvaluo.docRequisitoSeleccionado}"
                                    value="#{documento}" />
                            </p:commandButton>

                        </p:outputPanel>
                    </p:column>

                    <p:column>
                        <f:facet name="header">
                            Descripción
                        </f:facet>
                        <h:outputText value="#{documento.descripcion}"
                                      styleClass="outputTextStyle" />
                    </p:column>

                </p:dataTable>

                <h:panelGrid columns="3" style="text-align:right">
                    <h:outputLabel value="Descripción documento adicional:"
                                   styleClass="outputLabelStyle" />

                    <h:selectOneMenu converter="tipoDocumentoConverter"
                                     value="#{proyectarCotizacionAvaluo.tipoDocumentoSeleccionado}">

                        <f:selectItems
                            value="#{proyectarCotizacionAvaluo.listaDocumentacionASolicitar}"
                            var="tipoDoc" itemLabel="#{tipoDoc.nombre}" />

                        <p:ajax process="@this" />
                    </h:selectOneMenu>

                    <p:commandButton value="Adicionar" icon="ui-icon-document"
                                     onstart="statusDialog2.show();"
                                     action="#{proyectarCotizacionAvaluo.agregarDocumentoRequisito}"
                                     oncomplete="statusDialog2.hide();" update="docsRequisitoFS">
                    </p:commandButton>
                </h:panelGrid>

                <p:spacer width="15" />

                <h:panelGrid width="100%">
                    <p:spacer height="10" />
                    <h:outputLabel value="Observaciones adicionales"
                                   styleClass="outputLabelStyle" for="observacionesText" />
                    <h:inputTextarea id="observacionesText" rows="3" cols="180"
                                     value="#{proyectarCotizacionAvaluo.avaluo.observaciones}" />
                </h:panelGrid>


                <p:spacer width="15" />

                <p:outputPanel layout="block" style="text-align:left">

                    <p:spacer width="5" />

                    <p:commandButton value="Generar cotización"
                                     action="#{proyectarCotizacionAvaluo.generarOficioCotizacion}"
                                     icon="ui-icon ui-icon-document"
                                     oncomplete="statusDialog2.hide(); "
                                     onstart="statusDialog2.show();" update="docsRequisitoFS">
                    </p:commandButton>

                    <p:spacer width="5" />

                    <p:commandButton value="Vista previa" icon="ui-icon ui-icon-check"
                                     disabled="#{!proyectarCotizacionAvaluo.banderaOficioGenerado}"
                                     action="#{proyectarCotizacionAvaluo.verVistaPrevia}"
                                     onstart="statusDialog2.show();"
                                     oncomplete="statusDialog2.hide(); memorandoWV.show();">
                    </p:commandButton>

                    <p:spacer width="5" />

                    <p:commandButton value="Enviar a control de calidad"
                                     disabled="#{!proyectarCotizacionAvaluo.banderaOficioGenerado}"
                                     action="#{proyectarCotizacionAvaluo.enviarAControlCalidad}"
                                     icon="ui-icon ui-icon-circle-arrow-e"
                                     oncomplete="statusDialog2.hide();" onstart="statusDialog2.show();">
                    </p:commandButton>

                    <p:spacer width="5" />

                </p:outputPanel>
            </p:fieldset>

            <p:separator style="width:925px;height:3px" />

            <p:spacer height="7" />

            <p:outputPanel layout="block" style="text-align:right">
                <p:commandButton value="Cerrar"
                                 action="#{proyectarCotizacionAvaluo.cerrar}"
                                 icon="ui-icon-circle-close" immediate="true" ajax="false" />
                <p:spacer height="0" width="30" />
            </p:outputPanel>
            <p:spacer height="20" width="0" />


        </h:form>

        <!-- CC PARA CONFIRMAR ELIMINACION DE CAPITULO -->
        <misc:ultimateConfirmDialogCC
            confirmMessage="¿Está seguro de eliminar el capítulo?"
            confirmUpdateOnYes=":proyectarCotizacionAvaluoForm:proyectarCotizacionAvaluoCapitulosFS"
            confirmDialogWV="confirmacionEliminarCapituloWV"
            voidActionOnYes="#{proyectarCotizacionAvaluo.eliminarCapitulo}"
            yesLabel="Aceptar" noLabel="Cancelar" />

        <!-- CC PARA CONFIRMAR ELIMINACION DE DOCUMENTO REQUISITO -->
        <misc:ultimateConfirmDialogCC
            confirmMessage="¿Está seguro de eliminar el documento requisito?"
            confirmUpdateOnYes=":proyectarCotizacionAvaluoForm:docsRequisitoFS"
            confirmDialogWV="confirmacionEliminarDocRequisitoWV"
            voidActionOnYes="#{proyectarCotizacionAvaluo.borrarDocumentoRequisito}"
            yesLabel="Aceptar" noLabel="Cancelar" />

        <!-- DIALOG PARA CREAR/ACTUALIZAR UN CAPITULO -->
        <p:dialog header="Otra descripción/otro capítulo" dynamic="true"
                  widgetVar="otraDescOtroCapWV" width="462" height="255"
                  appendToBody="true" modal="true">
            <ui:include src="/avaluos/ejecucion/crearActualizarCapitulo.xhtml" />
        </p:dialog>

        <!-- CC PARA INFORMACION DE LA SOLICITUD -->
        <avaluos:informacionSolicitudCC id="isCC"
                                        thisWVName="infoSolicitudCCWV" thisId="isCC" mostrarInfoPago="false"
                                        detallePredioWVName="detallesPredioWV" detallePredioId="dpCC"
                                        infoPredialWVName="prediosWV" infoPredialId="pdsDialog"
                                        managedBean="#{consultaInformacionSolicitud}" />

        <!-- DIALOG PARA INFORMACION DEL SOLICITANTE -->
        <p:dialog header="Adicionar solicitante" dynamic="true"
                  widgetVar="addSolicitanteDialogWV" width="900" appendToBody="true"
                  modal="true">
            <p:panel header="Datos del solicitante">
                <ui:include src="/avaluos/util/capturaDatosSolicitante.xhtml">
                    <ui:param name="adicionarSolicitanteWvParam"
                              value="guardarSolicitanteConfirmationWV" />
                </ui:include>
            </p:panel>
        </p:dialog>

        <!-- DIALOG PARA INFORMACION DE DOCUMENTOS DE LA SOLICITUD -->
        <p:dialog id="adminAnexos" widgetVar="administrarAnexosWV"
                  header="Anexos relacionados" appendToBody="true" closable="true"
                  minimizable="false" dynamic="true" width="900">
            <ui:include src="/avaluos/ingresoSolicitud/administrarAnexos.xhtml">
                <ui:param name="managedBeanParam"
                          value="#{administracionDocumentacionAvaluoComercial}" />
            </ui:include>
        </p:dialog>


        <!-- DIALOG PARA INFORMACION PREDIAL -->
        <p:dialog widgetVar="infoPredialWV"
                  header="Información de los predios asociados al avalúo"
                  appendToBody="true" closable="true" minimizable="false"
                  resizable="false" dynamic="true" modal="true" width="850">
            <ui:include
                src="/avaluos/transversal/consultarInformacionPredial.xhtml" />
        </p:dialog>

        <!-- CC PARA INFORMACION DETALLADA DE PREDIOS -->
        <predio:detallesPredioCC id="dpCC" thisWVName="detallesPredioWV"
                                 mostrarDatosPropietarios="true" mostrarDatosTramites="false"
                                 mostrarFichaPredial="true" thisIdPlusColon=":dpCC" />

        <!-- DIALOG PARA INFORMACION DE DEPARTAMENTOS Y MUNICIPIOS DE LOS PREDIOS DE UN AVALUO -->
        <p:dialog widgetVar="infoDeptosMunisWV"
                  header="Municipios y departamentos asociados al avalúo"
                  appendToBody="true" closable="true" minimizable="false"
                  resizable="false" dynamic="true" modal="true" width="600">
            <ui:include
                src="/avaluos/transversal/consultarDepartamentosMunicipiosAvaluo.xhtml" />
        </p:dialog>

        <!-- DIALOG PARA INFORMACION DE AVALUADORES ASIGNADOS -->
        <p:dialog widgetVar="infoAvaluadoresAsignadosWV"
                  header="Profesionales de avalúos" appendToBody="true" closable="true"
                  minimizable="false" resizable="false" dynamic="true" modal="true"
                  width="750">
            <ui:include
                src="/avaluos/asignacion/consultarAvaluadoresAsignados.xhtml" />
        </p:dialog>

        <!-- CC PARA MOSTRAR DOCUMENTO -->
        <misc:visualizadorMemorandosCC id="viewMemo" thisWVName="memorandoWV"
                                       radicarButtonEnabled="false"
                                       urlDocumento="#{previsualizacionDocumento.reporteDTO.urlWebReporte}"
                                       fileContent="#{previsualizacionDocumento.reporteDTO.streamedContentReporte}" />

        <!-- VISOR GEOGRAFICO -->
        <ui:include src="/util/visorGeografico.xhtml" />

    </ui:define>
</ui:composition>

